/********************************************************************************
I CHING - The Book of Changes

Written by: Jorge Vilas
Copyright (C) 2006 Jorge Vilas. All Rights Reserved.

Version History:
2.0.0 (January 2006)
	- The 16 tokens method - Gem simulation
1.0.0 (January 2006)
	- Initial Release
 ********************************************************************************/

include("JV.js");

const stateLoading = 0x0004;
const stateTrans = 0x0008;
const wmOpen = 0x0002;
var state = 0;
var wm = 0;

// Dropdown items
var dropdownMenu = new Array();

var contextMenu = new Array();

function mainWindow_onContextMenu() {
	contextMenu[0].enabled = true;
	mainWindow.contextMenuItems = contextMenu;
}

var author = new MenuItem();
author = new MenuItem();
author.title = "About the Author";
author.onSelect = "AboutTheAuthor();";
contextMenu.push(author);

author = new MenuItem();
author.title = "Make a Donation";
author.onSelect = "Donate();";
contextMenu.push(author);
mainWindow.contextMenuItems = contextMenu;
mainWindow.onContextMenu = "mainWindow_onContextMenu()";

var Lang = "";
if (preferences.language.value == "English") {
	Lang = "en";
	} else {
	Lang = "es";
}

function updateLang() {
	openWindow();
	var theLanguage = preferences.language.value.replace(/ /g,"_");
	if (theLanguage == "English") {
		Lang = "en";
		} else {
		Lang = "es";
	}
	openWindow();
}

var state = 0;
var openSite = "closed";
var statusOracle = "firstTime";
var initMouseOver = false;
var castMouseOver = false;
var currentScreen = "closed";

// Create gemBagState_array
var gemBagState_array = new makeArray(16,2);
for(var i=1; i<17; i++) {
	gemBagState_array[i][1] = "Resources/Images/gem0.png";
	gemBagState_array[i][2] = "100";
}

// Create hexa_arrays
var hexa1_array = new Array();
var hexa2_array = new Array();

var hexaPointer = 0;
var suffledBag = false;

// Trigramas
var Trig1 = 0;
var Trig2 = 0;
var Trig3 = 0;
var Trig4 = 0;
var trigNum;

var Yaos_en = new Array ();
Yaos_en[6] = "Changing old yin";
Yaos_en[7] = "Stable young yang";
Yaos_en[8] = "Stable young yin";
Yaos_en[9] = "Changing old yang";

var Yaos_es = new Array ();
Yaos_es[6] = "Yin viejo mutante";
Yaos_es[7] = "Yang joven estable";
Yaos_es[8] = "Yin joven estable";
Yaos_es[9] = "Yang viejo mutante";

var Colors_en = new Array ();
Colors_en[6] = "A Blue gem";
Colors_en[7] = "A Yellow gem";
Colors_en[8] = "A Green gem";
Colors_en[9] = "A Red gem";

var Colors_es = new Array ();
Colors_es[6] = "Una gema Azul";
Colors_es[7] = "Una gema Amarilla";
Colors_es[8] = "Una gema Verde";
Colors_es[9] = "Una gema Roja";

var Hexagramas = new makeArray (7, 7);

Hexagramas[0][0] = "02";
Hexagramas[0][1] = "16";
Hexagramas[0][2] = "08";
Hexagramas[0][3] = "45";
Hexagramas[0][4] = "23";
Hexagramas[0][5] = "35";
Hexagramas[0][6] = "20";
Hexagramas[0][7] = "12";

Hexagramas[1][0] = "24";
Hexagramas[1][1] = "51";
Hexagramas[1][2] = "03";
Hexagramas[1][3] = "17";
Hexagramas[1][4] = "27";
Hexagramas[1][5] = "21";
Hexagramas[1][6] = "42";
Hexagramas[1][7] = "25";

Hexagramas[2][0] = "07";
Hexagramas[2][1] = "40";
Hexagramas[2][2] = "29";
Hexagramas[2][3] = "47";
Hexagramas[2][4] = "04";
Hexagramas[2][5] = "64";
Hexagramas[2][6] = "59";
Hexagramas[2][7] = "06";

Hexagramas[3][0] = "19";
Hexagramas[3][1] = "54";
Hexagramas[3][2] = "60";
Hexagramas[3][3] = "58";
Hexagramas[3][4] = "41";
Hexagramas[3][5] = "38";
Hexagramas[3][6] = "61";
Hexagramas[3][7] = "10";

Hexagramas[4][0] = "15";
Hexagramas[4][1] = "62";
Hexagramas[4][2] = "39";
Hexagramas[4][3] = "31";
Hexagramas[4][4] = "52";
Hexagramas[4][5] = "56";
Hexagramas[4][6] = "53";
Hexagramas[4][7] = "33";

Hexagramas[5][0] = "36";
Hexagramas[5][1] = "55";
Hexagramas[5][2] = "63";
Hexagramas[5][3] = "49";
Hexagramas[5][4] = "22";
Hexagramas[5][5] = "30";
Hexagramas[5][6] = "37";
Hexagramas[5][7] = "13";

Hexagramas[6][0] = "46";
Hexagramas[6][1] = "32";
Hexagramas[6][2] = "48";
Hexagramas[6][3] = "28";
Hexagramas[6][4] = "18";
Hexagramas[6][5] = "50";
Hexagramas[6][6] = "57";
Hexagramas[6][7] = "44";

Hexagramas[7][0] = "11";
Hexagramas[7][1] = "34";
Hexagramas[7][2] = "05";
Hexagramas[7][3] = "43";
Hexagramas[7][4] = "26";
Hexagramas[7][5] = "14";
Hexagramas[7][6] = "09";
Hexagramas[7][7] = "01";

var gem_choice_array = new Array();
var gem_array = new Array();
var gem_bag = new Object();
var gem_component_array = new Array();
var chooser;
var choice;

function makeArray (X, Y)	{
	var Count;
	this.length = X;
	for (var Count = 0; Count <= X; Count++)
	this[Count] = new makeArray(Y);
}

function openWindow() {
	if (openSite == "open") {
		Background.src = "Resources/Images/Background.png";
		Background.height = 1;
		Background.clipRect = 440,0,440,211;
		slideButton.src = "Resources/Images/Yin-Yang.png";
		Footer.vOffset = 37;
		closeOracle ();
		openSite = "closed";
		mainWindow.width = 440;
		mainWindow.height = 67;
	} else {
		mainWindow.width = 440;
		mainWindow.height = 280;
		Background.height = 211;
		Background.clipRect = 440,211,440,0;
		Background.src = "Resources/Images/Splash.png";
		slideButton.src = "Resources/Images/Yin-Yang.png";
		Footer.vOffset = 247;
		openSite = "open";
		initOracle();
	}
}

function initOracle() {
	currentScreen = "Splash";
	Background.src="Resources/Images/Splash.png";
	bookName = new Text();
	bookName.hOffset = 15;
	bookName.vOffset = 216;
	bookName.font = "Arial";
	bookName.size = "18";
	if (Lang == "es") {
		bookName .data = 'El libro de los cambios';
		} else {
		bookName .data = 'The Book of Changes';
	}
	btn_start = new Image();
	btn_start.src = "Resources/Images/btn_start_" + Lang + ".png";
	btn_start.hOffset = 50;
	btn_start.vOffset = 225;
	btn_start.width = 100;
	btn_start.height = 15;
	btn_start.opacity = 255;
	btn_start.onMouseUp = "btn_start_onMouseUp()";
}

function btn_start_onMouseUp() {
	if (statusOracle == "firstTime") openOracle();
}

function openOracle() {
	delete_currentScreen();
	currentScreen = "Cast";

	gemBag = new Array();
	gemBagSelection = new Array();
	var horzOffsetBase = 120;
	var vertOffsetBase = 64;
	var horzOffset = 0;
	var vertOffset = 0;

	for ( i = 1; i < 17; i++ ) {
		gemBag[i] = new Image();
		gemBag[i].src = "Resources/Images/gem0.png";
		gemBag[i].width = 30;
		gemBag[i].height = 30;

		if (i < 5) horzOffset = horzOffsetBase + (i * 30);
		if (i > 4) horzOffset = horzOffsetBase + ((i - 4) * 30);
		if (i > 8) horzOffset = horzOffsetBase + ((i - 8) * 30);
		if (i > 12) horzOffset = horzOffsetBase + ((i - 12) * 30);

		if (i < 5) vertOffset = vertOffsetBase + 30;
		if (i > 4) vertOffset = vertOffsetBase + 60;
		if (i > 8) vertOffset = vertOffsetBase + 90;
		if (i > 12) vertOffset = vertOffsetBase + 120;

		gemBag[i].hOffset = horzOffset;
		gemBag[i].vOffset = vertOffset;
		gemBag[i].opacity = 100;
		gemBag[i].zOrder = 3;

		gemBag[i].onMouseEnter = "";
		gemBag[i].onMouseExit = "";
		gemBag[i].onMouseDown = "";
		gemBag[i].onMouseUp = "";
	}
	Background.src="Resources/Images/Background.png";
	delete btn_start;
	statusOracle = "open";
	castHexa();
}

function castHexa() {
	if (statusOracle == "open") {
		Line = new Array();
		for ( i = 1; i < 7; i++ ) {
			Line[i] = new Image();
			Line[i].width = 41;
			Line[i].height = 7;
			Line[i].hOffset = 10;
			Line[i].vOffset = 87 - (i * 8);
			Line[i].opacity = 255;
		}
		Ideograma = new Image();
		Ideograma.hOffset = 56;
		Ideograma.vOffset = 40;
		Ideograma.width = 42;
		Ideograma.height = 41;
		Ideograma.opacity = 255;

		message1 = new TextArea();
		message1.width = 270;
		message1.height = 40;
		message1.hOffset = 90;
		message1.vOffset = 47;
		message1.font = "Arial";
		message1.size = "12";
		message1.editable = false;
		message1.scrollbar = false;
		message1.color = "#742104";
		message1.style = "bold";
		if (Lang == "en") {
			message1.data = 'Select six gems, one by one, to bulid up the hexagram with the answer for your question';
			} else {
			message1.data = 'Seleccione seis gemas, una por vez, para obtener el hexagrama para su consulta';
		}

		message2 = new TextArea();
		message2.width = 160;
		message2.height = 54;
		message2.hOffset = 274;
		message2.vOffset = 133;
		message2.font = "Arial";
		message2.size = "12";
		message2.editable = false;
		message2.scrollbar = false;
		message2.color = "#742104";
		message2.style = "bold";

		message3 = new Text();
		message3.width = 160;
		message3.height = 20;
		message3.hOffset = 274;
		message3.vOffset = 231;
		message3.font = "Arial";
		message3.size = "12";
		message3.color = "#742104";
		message3.style = "bold";

		nameHexa = new Text();
		nameHexa.hOffset = 100;
		nameHexa.vOffset = 58;
		nameHexa.font = "Arial";
		nameHexa.size = "12";
		nameHexa.style = "bold";

		titleHexa = new Text();
		titleHexa.hOffset = 100;
		titleHexa.vOffset = 74;
		titleHexa.font = "Arial";
		titleHexa.size = "12";
		titleHexa.style = "bold";

		buildGemBag();
	}
}

function buildGemBag() {
	currentScreen = "gemBag";
	btn_suffle = new Image();
	btn_suffle.src = "Resources/Images/btn_suffle_" + Lang + ".png";
	btn_suffle.hOffset = 162;
	btn_suffle.vOffset = 220;
	btn_suffle.width = 100;
	btn_suffle.height = 15;
	btn_suffle.opacity = 255;
	btn_suffle.onMouseEnter = "btn_suffle.opacity = 170";
	btn_suffle.onMouseExit = "btn_suffle.opacity = 255";
	btn_suffle.onMouseDown = "btn_suffle.opacity = 200";
	btn_suffle.onMouseUp = "";
	message2.data = '';
	if (Lang == "en") {
		message3.data = '< Click on "Suffle"';
		} else {
		message3.data = '< Pulse en "Mezclar"';
	}
	for(var i=16; i>0; i--) {
		sleep(1);
		gemBagState_array[i][1] = "Resources/Images/gem0.png";
		gemBagState_array[i][2] = "255";
		gemBag[i].src = gemBagState_array[i][1];
		gemBag[i].opacity = 100;
	}
	delete btn_next;
	btn_suffle.onMouseUp = "suffleBag()";
}

function suffleBag() {
	// shuffle the bag
	for(var i=1; i<17; i++) {
		sleep(1);
		gemBag[i].opacity = 170;
	}
	suffledBag = true;
	delete btn_suffle;
	selectGems();
	for(var i=1; i<17; i++) {
		gemBag[i].onMouseUp = "gemBag_onMouseUp(" + i + ")";
	}
	message3.data = '';
	message2.color = "#742104";
	if (Lang == "en") {
		message2.data = "\n< Click on a gem";
		} else {
		message2.data = "\n< Pulse sobre una gema";
	}
}

function gemBag_onMouseUp(pointer) {
	gemBag[pointer].src = "Resources/Images/gem" + gemBagSelection[pointer] + ".png";
	for(var i=1; i<17; i++) {
		gemBag[i].onMouseUp = "";
	}
	hexaPointer = hexaPointer + 1;
	buildHexa (hexaPointer,gemBagSelection[pointer]);
	if (hexaPointer <= 5) {
		btn_next = new Image();
		btn_next.src = "Resources/Images/btn_next_" + Lang + ".png";
		btn_next.hOffset = 162;
		btn_next.vOffset = 220;
		btn_next.width = 100;
		btn_next.height = 15;
		btn_next.opacity = 255;
		btn_next.onMouseEnter = "btn_next.opacity = 170";
		btn_next.onMouseExit = "btn_next.opacity = 255";
		btn_next.onMouseDown = "btn_next.opacity = 200";
		btn_next.onMouseUp = "buildGemBag()";
		if (Lang == "en") {
			var message = "" + Colors_en[gemBagSelection[pointer]] + "\n" + gemBagSelection[pointer] + " on line " + hexaPointer + "\n" + Yaos_en[gemBagSelection[pointer]];
			} else {
			var message = "" + Colors_es[gemBagSelection[pointer]] + "\n" + gemBagSelection[pointer] + " en l\u00EDnea " + hexaPointer + "\n" + Yaos_es[gemBagSelection[pointer]] ;
		}
		message2.color = "#000000";
		message2.data = message;
		if (Lang == "en") {
			message3.data = '< Click on "Next"';
			} else {
			message3.data = '< Pulse en "Siguiente"';
		}

		} else {
		closeBag(pointer);
	}
}

function selectGems() {
	gem_bag.blue = 1;
	gem_bag.red = 3;
	gem_bag.yellow = 5;
	gem_bag.green = 7;
	
	gem_choice_array.push("blue");
	gem_choice_array.push("red");
	gem_choice_array.push("yellow");
	gem_choice_array.push("green");

	for ( i = 1; i < 17; i++ ) {
		gemBagSelection[i] = gem();
	}
}

function gem() {
	do {
		chooser = randomize(3, false);
		choice = gem_bag[gem_choice_array[chooser]] > 0 ? gem_choice_array[chooser] : "";
	} while(choice == "");
	gem_array.push(choice);
	gem_bag[choice]--;
	switch (choice) {
		case "blue":
			gemBagChoice = 6;
			break;
		case "red":
			gemBagChoice = 9;
			break;
		case "yellow":
			gemBagChoice = 7;
			break;
		case "green":
			gemBagChoice = 8;
			break;
	}
	chooserSeed = rand(32);
	chooser = randomize(chooserSeed , true);
	choice = gem_array[chooser];
	return gemBagChoice;
}

function randomize(rng, useSeed) {
	if(useSeed) {
		var toParse = 32;
		var rand1 = (toParse / 32768);
		var res = Math.round(rand1 * rng);
	} else {
		var res = Math.round(Math.random() * rng);
	}
	return res;
}

function rand(maxNum)	{
	var theseed3 = 1;
	var theseed2 = 0;
	thedate=new Date();
	theseed = Math.sqrt(theseed3 * (47.3457373545383 + thedate.getSeconds()) * (91.7808957845674 + thedate.getMinutes()));
	theseed3 = 3495937 * (1000000 * theseed-Math.floor(1000000 * theseed))
		theseed2 = Math.floor(theseed3) % maxNum;
	return theseed2;
}

function closeBag(pointer) {
	message2.color = "#000000";
		if (Lang == "en") {
			var message = "" + Colors_en[gemBagSelection[pointer]] + "\n" + gemBagSelection[pointer] + " on line " + hexaPointer + "\n" + Yaos_en[gemBagSelection[pointer]];
			} else {
			var message = "" + Colors_es[gemBagSelection[pointer]] + "\n" + gemBagSelection[pointer] + " en linea " + hexaPointer + "\n" + Yaos_es[gemBagSelection[pointer]] ;
		}
		message2.data = message;
		if (Lang == "en") {
			message3.data = '< Click on "The Answer"';
			} else {
			message3.data = '< Pulse en "La Respuesta"';
		}
	delete btn_next;
	Consult();
}

function buildHexa (linePos,Yao) {
	if (linePos == 1) Line[1].src = "Resources/Images/Yao" + Yao + ".png";
	if (linePos == 2) Line[2].src = "Resources/Images/Yao" + Yao + ".png";
	if (linePos == 3) Line[3].src = "Resources/Images/Yao" + Yao + ".png";
	if (linePos == 4) Line[4].src = "Resources/Images/Yao" + Yao + ".png";
	if (linePos == 5) Line[5].src = "Resources/Images/Yao" + Yao + ".png";
	if (linePos == 6) Line[6].src = "Resources/Images/Yao" + Yao + ".png";

	hexa1_array[linePos] = Yao;
	hexa2_array[linePos] = Yao;
	if(linePos < 4) {
		regTrig1 (linePos, Yao);
		regTrig3 (linePos, Yao);
		} else {
		regTrig2 (linePos - 3, Yao);
		regTrig4 (linePos - 3, Yao);
	}
	if (linePos == 6) {
		delete btn_gemBags;
		delete message1;
		// Show texts of hexagram
		var hexaNum = Hexagramas[Trig1][Trig2];
		var xmlFile = "Resources/Book/Hexa" + hexaNum + Lang + ".xml";
		var xmlFileContent = filesystem.readFile(xmlFile).replace(/\r\n?/g, "\n");
		aNodes = new Array( "Numero", "Nombre", "Titulo" );
		aParsed = parseXML( xmlFileContent, aNodes );
		Ideograma.src = "Resources/Ideogramas/hexa" + hexaNum + ".png";
		nameHexa.data = hexaNum +  ". "  + aParsed["Nombre"][0];
		titleHexa.data = aParsed["Titulo"][0];
		Consult();
	}
}

function Consult() {
	var state_btn_answer = false;
	btn_answer = new Image();
	btn_answer.src = "Resources/Images/btn_answer_" + Lang + ".png";
	btn_answer.hOffset = 162;
	btn_answer.vOffset = 220;
	btn_answer.width = 100;
	btn_answer.height = 15;
	btn_answer.opacity = 255;
	btn_answer.onMouseEnter = "state_btn_answer = true; btn_answer.opacity = 170;";
	btn_answer.onMouseExit = "state_btn_answer = false; btn_answer.opacity = 255;";
	btn_answer.onMouseUp = "if (state_btn_answer) { btn_answer_onMouseUp(); }";
}

function btn_answer_onMouseUp() {
	delete_currentScreen();
	Answer();
}

function regTrig1 (toss,Yao)	{
	var Lt = 0;
	if (Yao == 6) Lt = 0;
	if (Yao == 7) Lt = 1;
	if (Yao == 8) Lt = 0;
	if (Yao == 9) Lt = 1;
	if (toss == 1) Trig1 = Lt;
	if (toss == 2) Trig1 = Trig1 + (Lt * 2);
	if (toss == 3) Trig1 = Trig1 + (Lt * 4);
}

function regTrig2 (toss,Yao)	{
	var Lt = 0;
	if (Yao == 6) Lt = 0;
	if (Yao == 7) Lt = 1;
	if (Yao == 8) Lt = 0;
	if (Yao == 9) Lt = 1;
	if (toss == 1) Trig2 = Lt;
	if (toss == 2) Trig2 = Trig2 + (Lt * 2);
	if (toss == 3) Trig2 = Trig2 + (Lt * 4);
}

function regTrig3 (toss,Yao)	{
	var Lt = 0;
	if (Yao == 6) Lt = 1;
	if (Yao == 7) Lt = 1;
	if (Yao == 8) Lt = 0;
	if (Yao == 9) Lt = 0;
	if (toss == 1) Trig3 = Lt;
	if (toss == 2) Trig3 = Trig3 + (Lt * 2);
	if (toss == 3) Trig3 = Trig3 + (Lt * 4);
}

function regTrig4 (toss,Yao)	{
	var Lt = 0;
	if (Yao == 6) Lt = 1;
	if (Yao == 7) Lt = 1;
	if (Yao == 8) Lt = 0;
	if (Yao == 9) Lt = 0;
	if (toss == 1) Trig4 = Lt;
	if (toss == 2) Trig4 = Trig4 + (Lt * 2);
	if (toss == 3) Trig4 = Trig4 + (Lt * 4);
}

function Answer() {
	delete_currentScreen();
	currentScreen = "Answer";

	// Show trigrams
	TrigInfTit = new Text();
	TrigInfTit.hOffset = 130;
	TrigInfTit.vOffset = 115;
	TrigInfTit.font = "Arial";
	TrigInfTit.size = "12";

	TrigSupTit= new Text();
	TrigSupTit.hOffset = 250;
	TrigSupTit.vOffset = 115;
	TrigSupTit.font = "Arial";
	TrigSupTit.size = "12";

	TrigRef = new TextArea();
	TrigRef.hOffset = 60;
	TrigRef.vOffset = 160;
	TrigRef.width = 80;
	TrigRef.height = 300;
	TrigRef.font = "Arial";
	TrigRef.size = "12";
	TrigRef.style = "italic";
	TrigRef.color = "#303030";
	TrigRef.editable = false;
	TrigRef.scrollbar = false;

	TrigInf = new Image();
	TrigInf.hOffset = 140;
	TrigInf.vOffset = 125;
	TrigInf.width = 25;
	TrigInf.height = 25;
	TrigInf.opacity = 255;

	Trig1Ideograma = new Image();
	Trig1Ideograma.hOffset = 175;
	Trig1Ideograma.vOffset = 125;
	Trig1Ideograma.width = 25;
	Trig1Ideograma.height = 25;
	Trig1Ideograma.opacity = 255;

	Trig1Datos = new TextArea();
	Trig1Datos.hOffset = 130;
	Trig1Datos.vOffset = 160;
	Trig1Datos.width = 120;
	Trig1Datos.height = 300;
	Trig1Datos.font = "Arial";
	Trig1Datos.size = "12";
	Trig1Datos.editable = false;
	Trig1Datos.scrollbar = false;

	TrigSup = new Image();
	TrigSup.hOffset = 260;
	TrigSup.vOffset = 125;
	TrigSup.width = 25;
	TrigSup.height = 25;
	TrigSup.opacity = 255;

	Trig2Ideograma = new Image();
	Trig2Ideograma.hOffset = 295;
	Trig2Ideograma.vOffset = 125;
	Trig2Ideograma.width = 25;
	Trig2Ideograma.height = 25;
	Trig2Ideograma.opacity = 255;

	Trig2Datos = new TextArea();
	Trig2Datos.hOffset = 250;
	Trig2Datos.vOffset = 160;
	Trig2Datos.width = 120;
	Trig2Datos.height = 300;
	Trig2Datos.font = "Arial";
	Trig2Datos.size = "12";
	Trig2Datos.editable = false;
	Trig2Datos.scrollbar = false;

	if (Lang == "es") {
		TrigRef.data = "Nombre:" + "\n\n" + "Cualidad:" + "\n" + "Imagen:" + "\n" + "Familia:";
		} else {
		TrigRef.data = "Name:" + "\n\n" + "Attribute:" + "\n" + "Image:" + "\n" + "Family:";
	}
	if (Lang == "es") {
		TrigInfTit.data = "Trigrama inferior";
		TrigSupTit.data = "Trigrama superior";
		} else {
		TrigInfTit.data = "Lower trigram";
		TrigSupTit.data = "Upper trigram";
	}
	var xmlFile = "Resources/Book/Trig" + Trig1 + Lang + ".xml";
	var xmlFileContent = filesystem.readFile (xmlFile);

	aNodes = new Array( "Numero", "Nombre", "Titulo", "Cualidad", "Imagen", "Familia" );
	aParsed = parseXML( xmlFileContent, aNodes );
	TrigInf.src = "Resources/Images/Trig" + Trig1 + ".png";
	Trig1Ideograma.src = "Resources/Ideogramas/Trig" + Trig1 + ".png";
	Trig1Datos.data = aParsed["Nombre"][0] + "\n" + aParsed["Titulo"][0] + "\n" + aParsed["Cualidad"][0] + "\n" + aParsed["Imagen"][0] + "\n" + aParsed["Familia"][0];

	xmlFile = "Resources/Book/Trig" + Trig2 + Lang + ".xml";
	xmlFileContent = filesystem.readFile (xmlFile);
	aParsed = parseXML( xmlFileContent, aNodes );
	TrigSup.src =  "Resources/Images/Trig" + Trig2 + ".png";
	Trig2Ideograma.src =  "Resources/Ideogramas/Trig" + Trig2 + ".png";
	Trig2Datos.data = aParsed["Nombre"][0] + "\n" + aParsed["Titulo"][0] + "\n" + aParsed["Cualidad"][0] + "\n" + aParsed["Imagen"][0] + "\n" + aParsed["Familia"][0];

	delete btn_answer;
	buildTextScreen();
}

function buildTextScreen() {
	answersArea = new TextArea();
	answersArea.width = 415;
	answersArea.height = 150;
	answersArea.hOffset = 10;
	answersArea.vOffset = 95;
	answersArea.font = "Arial";
	answersArea.size = "12";
	answersArea.editable = false;

	btn_present = new Image();
	btn_present.src = "Resources/Images/btn_present_" + Lang + ".png";
	btn_present.hOffset = 329;
	btn_present.vOffset = 39;
	btn_present.width = 100;
	btn_present.height = 15;
	btn_present.opacity = 255;
	btn_present.onMouseUp = "btn_present_onMouseUp()";

	btn_lines = new Image();
	btn_lines.src = "Resources/Images/btn_lines_" + Lang + ".png";
	btn_lines.hOffset = 329;
	btn_lines.vOffset = 55;
	btn_lines.width = 100;
	btn_lines.height = 15;
	btn_lines.opacity = 255;
	btn_lines.onMouseUp = "btn_lines_onMouseUp()";

	btn_future = new Image();
	btn_future.src = "Resources/Images/btn_future_" + Lang + ".png";
	btn_future.hOffset = 329;
	btn_future.vOffset = 71;
	btn_future.width = 100;
	btn_future.height = 15;
	btn_future.opacity = 255;
	btn_future.onMouseUp = "btn_future_onMouseUp()";
}

function btn_present_onMouseUp() {
	delete_currentScreen();
	buildTextScreen();
	thePresent();
}

function btn_lines_onMouseUp() {
	delete_currentScreen();
	buildTextScreen();
	movingLines();
}

function btn_future_onMouseUp() {
	delete_currentScreen();
	buildTextScreen();
	theFuture();
}

function parseXML( sXML, aTag ) {
	var aReturn = new Array();
	for ( i = 0; i < aTag.length; ++i ) {
		sPattern = new RegExp( "<" + aTag[i] + "([a-zA-Z0-9_-]*)>(.*)</" + aTag[i] + ">", "g" );
		aReturn[aReturn.length] = aTag[i];
		aReturn[aTag[i]] = sXML.match( sPattern );
		for ( k = 0; k < aReturn[aTag[i]].length; ++k ) {
			nStart = aReturn[aTag[i]][k].indexOf( ">" ) + 1;
			nEnd = aReturn[aTag[i]][k].indexOf( "</" );
			aReturn[aTag[i]][k] = aReturn[aTag[i]][k].substr( nStart, ( nEnd - nStart ) );
		}
	}
	return aReturn;
}

// The Present
function thePresent() {
	currentScreen = "thePresent";
	for (var linePos=1; linePos < 7; linePos++) {
		if (linePos == 1) Line[1].src = "Resources/Images/Yao" + hexa1_array[linePos] + ".png";
		if (linePos == 2) Line[2].src = "Resources/Images/Yao" + hexa1_array[linePos] + ".png";
		if (linePos == 3) Line[3].src = "Resources/Images/Yao" + hexa1_array[linePos] + ".png";
		if (linePos == 4) Line[4].src = "Resources/Images/Yao" + hexa1_array[linePos] + ".png";
		if (linePos == 5) Line[5].src = "Resources/Images/Yao" + hexa1_array[linePos] + ".png";
		if (linePos == 6) Line[6].src = "Resources/Images/Yao" + hexa1_array[linePos] + ".png";
	}
	var hexaNum = Hexagramas[Trig1][Trig2];
	var xmlFile = "Resources/Book/Hexa" + hexaNum + Lang + ".xml";
	var xmlFileContent = filesystem.readFile(xmlFile).replace(/\r\n?/g, "\n");
	aNodes = new Array( "Numero", "Nombre", "Titulo", "Imagen", "Dictamen" );
	aParsed = parseXML( xmlFileContent, aNodes );
	Ideograma.src = "Resources/Ideogramas/hexa" + hexaNum + ".png";
	nameHexa.data = hexaNum +  ". "  + aParsed["Nombre"][0];
	titleHexa.data = aParsed["Titulo"][0];
	if (Lang == "en") answersArea.data = "THE PRESENT" + "\n\n" + "THE JUDGEMENT" + "\n";
	if (Lang == "es") answersArea.data = "EL PRESENTE" + "\n\n" + "EL DICTAMEN" + "\n";
	answersArea.data = answersArea.data + aParsed["Dictamen"][0] + "\n\n";
	if (Lang == "en") answersArea.data = answersArea.data + "THE IMAGE" + "\n";
	if (Lang == "es") answersArea.data = answersArea.data + "LA IMAGEN" + "\n";
	answersArea.data = answersArea.data + aParsed["Imagen"][0] + "\n";
}

// Moving lines
function movingLines() {
	currentScreen = "movingLines";
	var changeLines = false;
	for (var linePos=1; linePos < 7; linePos++) {
		if (linePos == 1) Line[1].src = "Resources/Images/Yao" + hexa1_array[linePos] + ".png";
		if (linePos == 2) Line[2].src = "Resources/Images/Yao" + hexa1_array[linePos] + ".png";
		if (linePos == 3) Line[3].src = "Resources/Images/Yao" + hexa1_array[linePos] + ".png";
		if (linePos == 4) Line[4].src = "Resources/Images/Yao" + hexa1_array[linePos] + ".png";
		if (linePos == 5) Line[5].src = "Resources/Images/Yao" + hexa1_array[linePos] + ".png";
		if (linePos == 6) Line[6].src = "Resources/Images/Yao" + hexa1_array[linePos] + ".png";
	}
	var hexaNum = Hexagramas[Trig1][Trig2];
	var xmlFile = "Resources/Book/Hexa" + hexaNum + Lang + ".xml";
	var xmlFileContent = filesystem.readFile(xmlFile).replace(/\r\n?/g, "\n");
	aNodes = new Array( "Nombre", "Titulo", "Linea1", "Linea2", "Linea3", "Linea4", "Linea5", "Linea6" );
	aParsed = parseXML( xmlFileContent, aNodes );
	Ideograma.src = "Resources/Ideogramas/hexa" + hexaNum + ".png";
	nameHexa.data = hexaNum +  ". "  + aParsed["Nombre"][0];
	titleHexa.data = aParsed["Titulo"][0];

	var movLine6 = new Array();
	movLine6[1] = new Object();
	movLine6[1].es = "Seis al comienzo significa: ";
	movLine6[1].en = "Six at the beginning means: ";
	movLine6[2] = new Object();
	movLine6[2].es = "Seis en el segundo lugar significa: ";
	movLine6[2].en = "Six in the second place means: ";
	movLine6[3] = new Object();
	movLine6[3].es = "Seis en el tercer lugar significa: ";
	movLine6[3].en = "Six in the third place means: ";
	movLine6[4] = new Object();
	movLine6[4].es = "Seis en el cuarto lugar significa: ";
	movLine6[4].en = "Six in the fourth place means: ";
	movLine6[5] = new Object();
	movLine6[5].es = "Seis en el quinto lugar significa: ";
	movLine6[5].en = "Six in the fifth place means: ";
	movLine6[6] = new Object();
	movLine6[6].es = "Seis arriba significa: ";
	movLine6[6].en = "Six at the top means: ";

	var movLine9 = new Array();
	movLine9[1] = new Object();
	movLine9[1].es = "Nueve al comienzo significa: ";
	movLine9[1].en = "Nine at the beginning means: ";
	movLine9[2] = new Object();
	movLine9[2].es = "Nueve en el segundo lugar significa: ";
	movLine9[2].en = "Nine in the second place means: ";
	movLine9[3] = new Object();
	movLine9[3].es = "Nueve en el tercer lugar significa: ";
	movLine9[3].en = "Nine in the third place means: ";
	movLine9[4] = new Object();
	movLine9[4].es = "Nueve en el cuarto lugar significa: ";
	movLine9[4].en = "Nine in the fourth place means: ";
	movLine9[5] = new Object();
	movLine9[5].es = "Nueve en el quinto lugar significa: ";
	movLine9[5].en = "Nine in the fifth place means: ";
	movLine9[6] = new Object();
	movLine9[6].es = "Nueve arriba significa: ";
	movLine9[6].en = "Nine at the top means: ";

	if (Lang == "es") var answerLines = "LINEAS MUTANTES" + "\n\n";
	if (Lang == "en") var answerLines = "CHANGING LINES" + "\n\n";
	for (var linePos=1; linePos < 7; linePos++) {
		if (hexa1_array[linePos] == 6) {
			if (Lang == "es") answerLines = answerLines + movLine6[linePos].es + ":\n";
			if (Lang == "en") answerLines = answerLines + movLine6[linePos].en + ":\n";
			answerLines = answerLines + aParsed["Linea" + linePos][0] + "\n\n";
			changeLines = true;
		}
		if (hexa1_array[linePos] == 9) {
			if (Lang == "es") answerLines = answerLines + movLine9[linePos].es + ":\n";
			if (Lang == "en") answerLines = answerLines + movLine9[linePos].en + ":\n";
			answerLines = answerLines + aParsed["Linea" + linePos][0] + "\n\n";
			changeLines = true;
		}
	}
	if (changeLines) {
		answersArea.data = answerLines;
	} else {
	if (Lang == "es") answersArea.data =  "NO HAY LINEAS MUTANTES";
	if (Lang == "en") answersArea.data =  "NO CHANGING LINES";
	}
}

// The Future
function theFuture() {
	currentScreen = "theFuture";
	for (var linePos=1; linePos < 7; linePos++) {
		if (hexa2_array[linePos] == 6) hexa2_array[linePos] = 7;
		if (hexa2_array[linePos] == 9) hexa2_array[linePos] = 8;
		if (linePos == 1) Line[1].src = "Resources/Images/Yao" + hexa2_array[linePos] + ".png";
		if (linePos == 2) Line[2].src = "Resources/Images/Yao" + hexa2_array[linePos] + ".png";
		if (linePos == 3) Line[3].src = "Resources/Images/Yao" + hexa2_array[linePos] + ".png";
		if (linePos == 4) Line[4].src = "Resources/Images/Yao" + hexa2_array[linePos] + ".png";
		if (linePos == 5) Line[5].src = "Resources/Images/Yao" + hexa2_array[linePos] + ".png";
		if (linePos == 6) Line[6].src = "Resources/Images/Yao" + hexa2_array[linePos] + ".png";
	}
	for (var linePos=1; linePos < 7; linePos++) {
		if (hexa2_array[linePos] == 6) hexa2_array[linePos] = 7;
		if (hexa2_array[linePos] == 9) hexa2_array[linePos] = 8;
		if (linePos == 1) Line[1].src = "Resources/Images/Yao" + hexa2_array[linePos] + ".png";
		if (linePos == 2) Line[2].src = "Resources/Images/Yao" + hexa2_array[linePos] + ".png";
		if (linePos == 3) Line[3].src = "Resources/Images/Yao" + hexa2_array[linePos] + ".png";
		if (linePos == 4) Line[4].src = "Resources/Images/Yao" + hexa2_array[linePos] + ".png";
		if (linePos == 5) Line[5].src = "Resources/Images/Yao" + hexa2_array[linePos] + ".png";
		if (linePos == 6) Line[6].src = "Resources/Images/Yao" + hexa2_array[linePos] + ".png";
	}
	var hexaNum = Hexagramas[Trig3][Trig4];
	var xmlFile = "Resources/Book/Hexa" + hexaNum + Lang + ".xml";
	var xmlFileContent = filesystem.readFile(xmlFile).replace(/\r\n?/g, "\n");
	aNodes = new Array( "Numero", "Nombre", "Titulo", "Imagen", "Dictamen" );
	aParsed = parseXML( xmlFileContent, aNodes );
	Ideograma.src = "Resources/Ideogramas/hexa" + aParsed["Numero"][0] + ".png";
	nameHexa.data = hexaNum + ". " + aParsed["Nombre"][0];
	titleHexa.data = aParsed["Titulo"][0];
	if (Lang == "en") answersArea.data = "THE FUTURE" + "\n\n";
	if (Lang == "es") answersArea.data = "EL FUTURO" + "\n\n";
	answersArea.data = answersArea.data + aParsed["Imagen"][0] + "\n";
}

function closeOracle() {
	delete_currentScreen();
	if (statusOracle == "open") delete_Hexagram();
	state = 0;
	openSite = "closed";
	statusOracle = "firstTime";
	initMouseOver = false;
	castMouseOver = false;
	currentScreen = "closed";
	hexaPointer = 0;
}

function delete_currentScreen() {

if (currentScreen == "gemBag") {
	for(var i=1; i<17; i++) {
		delete gemBag[i];
	}
	delete btn_suffle;
	delete btn_next;
	delete btn_answer;
	delete message1;
	delete message2;
	delete message3;
}

if (currentScreen == "Answer") {
	delete TrigRef;
	delete TrigInfTit;
	delete TrigInf;
	delete Trig1Ideograma;
	delete Trig1Datos;
	delete TrigSupTit;
	delete TrigSup;
	delete Trig2Ideograma;
	delete Trig2Datos;
	delete btn_present;
	delete btn_lines;
	delete btn_future;
	}

if (currentScreen == "Cast") {
	delete message1;
	delete btn_gemBags;
	delete gemBag1;
	delete gemBag2;
	delete gemBag3;
	delete shadow1;
	delete shadow2;
	delete shadow3;
	delete btn_answer;
	}

if (currentScreen == "thePresent") {
	delete answersArea;
	delete btn_present;
	delete btn_lines;
	delete btn_future;
	}

if (currentScreen == "movingLines") {
	delete answersArea;
	delete btn_present;
	delete btn_lines;
	delete btn_future;
	}

if (currentScreen == "theFuture") {
	delete answersArea;
	delete btn_present;
	delete btn_lines;
	delete btn_future;
	}

if (currentScreen == "Splash") {
	delete bookName
}

}

// Delete Hexagram
function delete_Hexagram() {
	delete Line[1];
	delete Line[2];
	delete Line[3];
	delete Line[4];
	delete Line[5];
	delete Line[6];
	delete Ideograma;
	delete nameHexa;
	delete titleHexa;
}

